package api

import (
	"gadmin/internal/admin/forms"
	"gadmin/internal/admin/service"
	"github.com/gin-gonic/gin"
	"net/http"
)

func ChapterOrdinaryList(c *gin.Context) {
	var req forms.ChapterOrdinaryListReq
	if err := c.ShouldBind(&req); err != nil {
		c.JSON(200, ErrorResponse(err))
		return
	}

	if err := forms.ParseParams(&req); err != nil {
		c.JSON(200, ErrorResponse(err))
		return
	}

	c.JSON(200, service.Chapter.OrdinaryList(c, req))
}

func ChapterActivityList(c *gin.Context) {
	var req forms.ChapterActivityListReq
	if err := c.ShouldBind(&req); err != nil {
		c.JSON(200, ErrorResponse(err))
		return
	}

	if err := forms.ParseParams(&req); err != nil {
		c.JSON(200, ErrorResponse(err))
		return
	}

	c.JSON(200, service.Chapter.ActivityList(c, req))
}

func ChapterReconnect(ctx *gin.Context) {
	var params forms.ChapterReconnectReq
	err := ctx.ShouldBindQuery(&params)

	if err != nil {
		ctx.JSON(http.StatusOK, ErrorResponse(err))
		return
	}

	ctx.JSON(200, service.Chapter.Reconnect(ctx, params))
}
